#include <bits/stdc++.h>
using namespace std;
typedef long long int ll;
typedef vector<vector<ll>> graph;

const ll X=13;
ll N, M;
const char DEF = '.';
vector<string> s;
vector<vector<ll>> comp;
ll group_count = 0;

struct Pos{
    ll row, col;
    bool operator<(const Pos&c)const{
        return row!=c.row?row<c.row:col<c.col;
    }
    vector<Pos> neighbors()const{
        vector<Pos> res;
        if(col+1<M)  res.push_back({row,col+1});
        if(col-1>=0) res.push_back({row,col-1});
        if(row+1<N)  res.push_back({row+1,col});
        if(row-1>=0) res.push_back({row-1,col});
        return res;
    }
};
vector<Pos> representant;

void print(vector<ll> &a){
    for(ll n:a){
        assert(0 <= n && n < 26);
        cout<<(char)('a'+n);
    }
    cout<<endl;
}

// label a connected component with respective component_id
void label(Pos pos){
    if(comp[pos.row][pos.col] != -1) return;
    ll c_id = group_count++;
    char symbol = s[pos.row][pos.col];
    queue<Pos> q;
    q.push(pos);
    comp[pos.row][pos.col]=c_id;
    representant.push_back(pos);
    while(!q.empty()){
        Pos el = q.front(); q.pop();
        if(el < representant.back()) representant[representant.size()-1] = el;
        for(Pos n:el.neighbors())if(s[n.row][n.col]==symbol && comp[n.row][n.col]==-1){
            q.push(n);
            comp[n.row][n.col]=c_id;
        }
    }
}

void add(set<Pos> &sets, Pos lt, Pos rd){
    sets.insert(Pos{lt.row,lt.col});
    sets.insert(Pos{lt.row,rd.col});
    sets.insert(Pos{rd.row,lt.col});
    sets.insert(Pos{rd.row,rd.col});
}

void draw(vector<ll> &a){
    set<Pos> swap_positions;
    ll NN=min(3000ll,10+4*(ll)a.size()), MM=min(3000ll,60+2*(ll)a.size());
    Pos left_top={0,0}, right_bot={NN, MM};
    add(swap_positions, left_top, right_bot);
    for(ll n:a){
        if(n!=0){
            for(ll i=0; i<n; ++i){
                Pos p = Pos{left_top.row+1,left_top.col+1+2*i};
                add(swap_positions, p, Pos{p.row+1,p.col+1});
            }
            left_top.row += 2;
        }
        left_top.row+=1;  left_top.col+=1;
        right_bot.row-=1; right_bot.col-=1;
        add(swap_positions, left_top, right_bot);
    }
    vector<ll> prev(MM,'.');
    auto it = swap_positions.begin();
    cout << NN << ' ' << MM << endl;
    for(ll r=0; r<NN; ++r){
        ll q = 0;
        for(ll c=0; c<MM; ++c){
            // cout << r << ' ' << c << ' ' << it->row << ' ' << it->col << endl;
            if(it->row == r && it->col == c){
                q ^= X;
                ++it;
            }
            prev[c] ^= q;
            printf("%c", (char)prev[c]);
        }
        while(it->row == r)++it;
        printf("\n");
    }
}

int main(int argc, char **argv){
    cin >> N >> M;
    N += 2;
    M += 2;
    comp=vector<vector<ll>>(N, vector<ll>(M,-1));
    s.push_back(string(M,DEF));
    for(ll i=0; i<N-2; ++i){
         string in; cin >> in;
         s.push_back(DEF + in + DEF);
    }
    s.push_back(string(M,DEF));

    // label the outer layer
    for(ll r=0; r<N; ++r) for(ll c=0; c<M; ++c) label(Pos{r,c});
    // for(ll r=0; r<N; ++r){ for(ll c=0; c<M; ++c) cout << comp[r][c] <<' ';cout<<endl;}
    // compute which components touch
    vector<set<ll>> g(group_count);
    for(ll r=0; r<N; ++r) for(ll c=0; c<M-1; ++c){ ll a = comp[r][c], b = comp[r][c+1]; if(a!=b){ g[a].insert(b); g[b].insert(a); } }
    for(ll r=0; r<N-1; ++r) for(ll c=0; c<M; ++c){ ll a = comp[r][c], b = comp[r+1][c]; if(a!=b){ g[a].insert(b); g[b].insert(a); } }
    vector<set<Pos>> t(group_count);
    {
        vector<pair<ll,ll>> st;
        st.push_back({0,0});
        while(!st.empty()){
            auto p = st.back(); st.pop_back();
            ll el = p.first;
            ll par = p.second;
            for(ll n:g[el])if(n!=par){
                assert(t[n].empty());
                t[el].insert(representant[n]);
                st.push_back({n,el});
            }
        }
    }
    vector<ll> res;
    {
        vector<ll> st;
        st.push_back(0);
        while(!st.empty()){
            ll el = st.back(); st.pop_back();
            if(t[el].size()) res.push_back(t[el].size()-1);
            for(auto it=t[el].rbegin(); it!=t[el].rend(); ++it){
                Pos n=*it;
                st.push_back(comp[n.row][n.col]);
            }
        }
        reverse(res.begin(),res.end());
        res.pop_back();
    }
    // print(res);
    draw(res);

    // for(string &ss:s) { for(char c:ss) cerr << (char)(c); cerr << endl; }
    return 0;
}
